import React, {Fragment} from 'react'
import FormCategory from './FormCategory'
import FormInProgress from './FormInProgress'
import FormFinished from './FormFinished'
import StartNext from './StartNext'

import FormHelper from './../util/FormHelper'

const renderForm = (props) => {
    if (new FormHelper(props.form).isFinished() === false) {
        return <FormInProgress form={props.form}/>
    } else {
        return <FormFinished form={props.form}/>
    }
}

const getNext = (props) => new FormHelper(props.form).getNext()

export default function Form(props) {
    return (
        <Fragment>
            <FormCategory category={props.form.category}/>
            {renderForm(props)}
            <StartNext next={getNext(props)}/>
        </Fragment>
    )
}