import React from 'react'
import {Container, Row, Col} from 'react-bootstrap'
import FormTopThree from './FormTopThree'
import FormNotTopThree from './FormNotTopThree'
import { PosedBottomToTop, PosedDropIn } from '../util/PosedPresets'

import FormHelper from './../util/FormHelper'

export default class FormFinished extends React.Component {

    getTop3 = () => new FormHelper(this.props.form).getTop3()

    renderTop3 = () => {
        return this.getTop3().map((start, index) => 
            <PosedDropIn key={'topThree-' + index} className={''} initialPose={'ready'} pose={'drop'} i={index * 6}>
                <Row className={'border border-3 border-white rounded mb-3'}>
                    <Col>
                        <FormTopThree start={start} index={index}/>
                    </Col>
                </Row>
            </PosedDropIn>
        )
    }

    getNotTop3 = () => this.props.form.starts
                        .filter(start => this.props.start === undefined || start.competitors.toString() !== this.props.start.competitors.toString())
                        .slice(this.getTop3().length)

    renderNotTop3 = () => {
        return this.getNotTop3().map((start, index) => 
            <Col sm={12} md={6} xl={4} key={'notTopThree-' + index} className={'mb-2'}>
                <PosedBottomToTop className={''} initialPose={'hidden'} pose={'visible'} i={index + 20}>
                    <div className={'border border-3 border-white rounded pl-2 pr-4'}>
                        <FormNotTopThree start={start} index={index + 3} className={''}/>
                    </div>
                </PosedBottomToTop>
            </Col>
        )
    }

    render() {
        return (
            <div className={'mt-3 mx-3'}>
                <Container fluid={true} className={'font-size-form-starter'}>
                    {this.renderTop3()}
                    <Row>
                        {this.renderNotTop3()}
                    </Row>
                </Container>
            </div>
        )
    }
}