import React from 'react'
import {Container, Row, Col} from 'react-bootstrap'
import { PosedLeftToRight } from '../util/PosedPresets'
import StartHelper from './../util/StartHelper'

export default function FormStarter(props) {
    return (
        <div className={'mt-3 mx-3'}>
            <Container fluid={true} className={'font-size-form-starter'}>
                {props.starts.map((start, index) => (
                    <Row key={'start-' + index} className={''}>
                        <Col>
                            <PosedLeftToRight className={getClassName(start)} initialPose={'hidden'} pose={'visible'} i={index}>
                                {new StartHelper(start).getCompetitorsDisplay()}
                            </PosedLeftToRight>
                        </Col>
                    </Row>
                ))}
            </Container>
        </div>
    )

    function getClassName(start) {
        const startHelper = new StartHelper(start)
        const baseClasses = 'text-center font-weight-bold border border-3 border-white rounded my-2 p-3 bg-black'
        return startHelper.isDisabled() ? baseClasses + ' font-disabled' : baseClasses + ' text-white'
    }
}