import React from 'react'
import {Container, Row, Col} from 'react-bootstrap'
import FormTopThree from './FormTopThree'
import FormNotTopThree from './FormNotTopThree'
import { PosedRightToLeft } from '../util/PosedPresets'

export default class FormStarterResult extends React.Component {

    renderResult(start, index) {
        if (index < 3) {
            return <FormTopThree start={start} index={index}/>
        } else {
            return <FormNotTopThree start={start} index={index}/>
        }
    }

    render() {
        return (
            <div className={'mt-3 mx-3'}>
                <Container fluid={true} className={'font-size-form-starter'}>
                    {this.props.starts.map((start, index) => (
                        <PosedRightToLeft key={'startresult-' + index} className={''} initialPose={'hidden'} pose={'visible'} i={index}>
                            <Row className={'border border-3 border-white rounded mb-3'}>
                                <Col>
                                    {this.renderResult(start, index)}
                                </Col>
                            </Row>
                        </PosedRightToLeft>
                    ))}
                </Container>
            </div>
        )
    }
}