import React from 'react'
import {Container, Row, Col} from 'react-bootstrap'

import StartHelper from './../util/StartHelper'

export default class FormTopThree extends React.Component {

    getResultDisplay(start) {
        const hasFiveResults = new StartHelper(start).sortByResults().length === 5
        return new StartHelper(start).sortByResults().map((result, index) => 
            <Col key={`result-${index}`} className={this.getResultDisplayClassName(hasFiveResults, index)}>{result.toFixed(2)}</Col>
        )
    }

    getResultDisplayClassName(hasFiveResults, index) {
        if (hasFiveResults) {
            if (index === 0 || index === 4) {
                return 'form-result-invalid'
            }
        }
        return ''
    }

    getPlacementClassName(index) {
        switch (index) {
            case 0: return 'font-size-overall-standing-top-3 text-center text-white bg-gold'
            case 1: return 'font-size-overall-standing-top-3 text-center text-black bg-silver'
            case 2: return 'font-size-overall-standing-top-3 text-center text-black bg-bronze'
            default: return 'font-size-overall-standing-top-3 text-center text-black bg-gray'
        }
    }

    render() {
        return (
            <Container fluid={true} className={'font-size-form-starter text-white font-weight-bold p-0 m-0'}>
                <Row className={''}>
                    <Col sm={1} className={this.getPlacementClassName(this.props.index)}>
                        {this.props.index + 1}
                    </Col>
                    <Col sm={11}>
                        <Row className={'border-bottom'}>
                            <Col sm={10} className={'text-left'}>
                                {new StartHelper(this.props.start).getCompetitorsDisplay()}
                            </Col>
                            <Col sm={2} className={'text-right'}>
                                {new StartHelper(this.props.start).getOverallStandingDisplay()}
                            </Col>
                        </Row>
                        <Row className={'text-center font-size-form-starter-result-detail'}>
                            {this.getResultDisplay(this.props.start)}
                        </Row>
                    </Col>
                </Row>
            </Container>
        )
    }
}