import React from 'react'

import RoundWarnings from './RoundWarnings'
import RoundAhead from './RoundAhead'
import RoundCurrent from './RoundCurrent'
import RoundResult from './RoundResult'

import RoundsHelper from '../util/RoundsHelper'

const getWarnings = (props) => <RoundWarnings data={props.data}/>

const getRoundsResult = (props) => props.data.results
    .map((result, index) => <RoundResult key={'roundResult-' + index + 1} number={index + 1} result={result}/>)

const getRoundCurrent = (props) => {
    const roundsHelper = new RoundsHelper(props.data)
    if (roundsHelper.getNumberCurrentRound() > 0 && roundsHelper.isTied() === false) {
        return <RoundCurrent data={props.data} number={roundsHelper.getNumberCurrentRound()}/>
    }
}

const getRoundsAhead = (props) => {
    const roundsHelper = new RoundsHelper(props.data)
    const numberCurrentRound = roundsHelper.getNumberCurrentRound()
    let result = []
    for (let i = 0; i < roundsHelper.getNumberRoundsAhead(); i++) {
        result.push(<RoundAhead key={'roundAhead-' + i + 1} number={numberCurrentRound + i + 1}/>)
    }
    return result
}

function RoundDisplay(props) {
    return (
        <div className={'round-wrapper mx-auto'}>
            {getWarnings(props)}
            {getRoundsResult(props)}
            {getRoundCurrent(props)}
            {getRoundsAhead(props)}
        </div>
    )
}

export default RoundDisplay