import React from 'react'
import {Container, Row, Col} from 'react-bootstrap'
// https://www.npmjs.com/package/react-card-flip
import ReactCardFlip from 'react-card-flip'

import logo_cki from '../images/logo_cki_black.png'
import logo_gckf from '../images/logo_gckf_black.png'

export default class Waiting extends React.Component {

    constructor(props) {
        super(props)
        this.state = {
             isFlipped: false
        }
    }

    componentDidMount() {
        this.interval = setInterval(() => {
            this.setState(prevState => ({ 
                isFlipped: prevState.isFlipped === false 
            }))
        }, this.props.speed * 1000)
    }

    componentWillUnmount() {
        clearInterval(this.interval)
        this.interval = undefined
    }

    render() {
        return (
            <Container className={''}>
                <Row className={'align-items-center justify-content-center'} style={{height: '600px'}}>
                    <Col className={'text-center'}>
                        <ReactCardFlip 
                            isFlipped={this.state.isFlipped} 
                            infinite={true} 
                            flipSpeedBackToFront={this.props.speed}
                            flipSpeedFrontToBack={this.props.speed}>
                                <img src={logo_gckf} alt={'Logo GCKF'} height={500} key="front"/>
                                <img src={logo_cki} alt={'Logo CKI'} height={500} key="back"/>
                        </ReactCardFlip>
                    </Col>
                </Row>
            </Container>
        )
    }
}