import FightsHelper from './../util/FightsHelper'
import Point from './../util/Point'
import Constants from './../util/Constants'
import Winner from './../util/Winner'

it('new FightsHelper()', () => {
  const fightsHelper = new FightsHelper(fights_empty)
  expect(fightsHelper).toBeDefined()
})

it('getRed()', () => {
  const fightsHelper = new FightsHelper(fights_1)
  expect(fightsHelper.getRed('')).toBe(Constants.UNKNOWN_FIGHTER)
  expect(fightsHelper.getRed('gibts-nicht')).toBe(Constants.UNKNOWN_FIGHTER)
  expect(fightsHelper.getRed('fight-0')).toBe(Constants.UNKNOWN_FIGHTER)
  expect(fightsHelper.getRed('fight-1')).toBe('Thomas Treffer')
  expect(fightsHelper.getRed('fight-2')).toBe('Wendy')
  expect(fightsHelper.getRed('fight-3')).toBe('Wendy')
  expect(fightsHelper.getRed('fight-4')).toBe('Klaus')
  expect(fightsHelper.getRed('fight-5')).toBe(Constants.LOSER_OF_FIGHT + ' 3')
  expect(fightsHelper.getRed('fight-6')).toBe(Constants.UNKNOWN_FIGHTER)
})

it('getBlue()', () => {
  const fightsHelper = new FightsHelper(fights_1)
  expect(fightsHelper.getBlue('')).toBe(Constants.UNKNOWN_FIGHTER)
  expect(fightsHelper.getBlue('gibts-nicht')).toBe(Constants.UNKNOWN_FIGHTER)
  expect(fightsHelper.getBlue('fight-0')).toBe(Constants.UNKNOWN_FIGHTER)
  expect(fightsHelper.getBlue('fight-1')).toBe('Peter Treffer')
  expect(fightsHelper.getBlue('fight-2')).toBe('Klaus')
  expect(fightsHelper.getBlue('fight-3')).toBe('Thomas Treffer')
  expect(fightsHelper.getBlue('fight-4')).toBe('Peter Treffer')
  expect(fightsHelper.getBlue('fight-5')).toBe(Constants.WINNER_OF_FIGHT + ' 4')
  expect(fightsHelper.getBlue('fight-6')).toBe(Constants.UNKNOWN_FIGHTER)
})

it('isCurrent()', () => {
  const fightsHelper = new FightsHelper(fights_1)
  expect(fightsHelper.isCurrent('')).toBe(false)
  expect(fightsHelper.isCurrent('gibts-nicht')).toBe(false)
  expect(fightsHelper.isCurrent('fight-0')).toBe(false)
  expect(fightsHelper.isCurrent('fight-1')).toBe(false)
  expect(fightsHelper.isCurrent('fight-2')).toBe(false)
  expect(fightsHelper.isCurrent('fight-3')).toBe(true)
  expect(fightsHelper.isCurrent('fight-4')).toBe(false)
  expect(fightsHelper.isCurrent('fight-5')).toBe(false)
  expect(fightsHelper.isCurrent('fight-6')).toBe(false)
})

it('isCurrent()', () => {
  const fightsHelper = new FightsHelper(fights_empty)
  expect(fightsHelper.isCurrent('')).toBe(false)
  expect(fightsHelper.isCurrent('gibts-nicht')).toBe(false)
  expect(fightsHelper.isCurrent('fight-0')).toBe(false)
  expect(fightsHelper.isCurrent('fight-1')).toBe(false)
  expect(fightsHelper.isCurrent('fight-2')).toBe(false)
  expect(fightsHelper.isCurrent('fight-3')).toBe(false)
  expect(fightsHelper.isCurrent('fight-4')).toBe(false)
  expect(fightsHelper.isCurrent('fight-5')).toBe(false)
  expect(fightsHelper.isCurrent('fight-6')).toBe(false)
})

const fights_empty = []

const fights_1 = [
  {
    id: 'fight-1',
    number: 1,
    category: "Beginners A - 25 kg - 34 kg",
    blue: "Peter Treffer",
    blueImg: "",
    red: "Thomas Treffer",
    redImg: "",
    rounds: {
        max: 5,
        warnings: {},
        results: [{
          red: Point.WINNER,
          blue: Point.KO
        }],
        stopWatch: {
            start: 180000
        }
    }
  }, 
  {
    id: 'fight-2',
    number: 2,
    category: "Beginners A - 25 kg - 34 kg",
    blue: "Klaus",
    blueImg: "",
    red: "Wendy",
    redImg: "",
    rounds: {
        max: 5,
        warnings: {},
        results: [{
          red: Point.WINNER,
          blue: Point.KO
        }],
        stopWatch: {
            start: 180000
        }
    }
  },  
  {
    id: 'fight-3',
    number: 3,
    category: "Beginners A - 25 kg - 34 kg",
    blue: "+fight-1",
    blueImg: "",
    red: "+fight-2",
    redImg: "",
    rounds: {
        max: 5,
        warnings: {},
        results: [],
        stopWatch: {
            start: 180000
        } 
    }
  },  
  {
    id: 'fight-4',
    number: 4,
    category: "Beginners A - 25 kg - 34 kg",
    blue: "-fight-1",
    blueImg: "",
    red: "-fight-2",
    redImg: "",
    rounds: {
        max: 5,
        warnings: {},
        results: [],
        stopWatch: {
            start: 180000
        } 
    }
  },  
  {
    id: 'fight-5',
    number: 5,
    category: "Beginners A - 25 kg - 34 kg",
    blue: "+fight-4",
    blueImg: "",
    red: "-fight-3",
    redImg: "",
    rounds: {
        max: 5,
        warnings: {},
        results: [],
        stopWatch: {
            start: 180000
        } 
    }
  }
]
