import RoundHelper from './../util/RoundHelper'
import Point from './../util/Point'
import Winner from './../util/Winner'

it('new RoundHelper()', () => {
  const roundHelper = new RoundHelper()
  expect(roundHelper).toBeDefined()
})

it('hasPoints()', () => {
  expect(new RoundHelper(round_empty).hasPoints()).toBe(false)
  expect(new RoundHelper(round_points_red).hasPoints()).toBe(true)
  expect(new RoundHelper(round_points_blue).hasPoints()).toBe(true)
  expect(new RoundHelper(round_points_only_blue).hasPoints()).toBe(true)
  expect(new RoundHelper(round_status_red).hasPoints()).toBe(false)
  expect(new RoundHelper(round_status_blue).hasPoints()).toBe(false)
  expect(new RoundHelper(round_only_warning_blue).hasPoints()).toBe(false)
  expect(new RoundHelper(round_only_warning_red).hasPoints()).toBe(false)
  expect(new RoundHelper(round_only_warning).hasPoints()).toBe(false)
  expect(new RoundHelper(round).hasPoints()).toBe(true)
})

it('hasStatus()', () => {
  expect(new RoundHelper(round_empty).hasStatus()).toBe(false)
  expect(new RoundHelper(round_points_red).hasStatus()).toBe(false)
  expect(new RoundHelper(round_points_blue).hasStatus()).toBe(false)
  expect(new RoundHelper(round_points_only_blue).hasStatus()).toBe(false)
  expect(new RoundHelper(round_status_red).hasStatus()).toBe(true)
  expect(new RoundHelper(round_status_blue).hasStatus()).toBe(true)
  expect(new RoundHelper(round_only_warning_blue).hasStatus()).toBe(false)
  expect(new RoundHelper(round_only_warning_red).hasStatus()).toBe(false)
  expect(new RoundHelper(round_only_warning).hasStatus()).toBe(false)
  expect(new RoundHelper(round).hasPoints()).toBe(true)
})

it('getWinner()', () => {
  expect(new RoundHelper(round_empty).getWinner()).toBe(Winner.NONE)
  expect(new RoundHelper(round_points_red).getWinner()).toBe(Winner.RED)
  expect(new RoundHelper(round_points_blue).getWinner()).toBe(Winner.BLUE)
  expect(new RoundHelper(round_points_only_blue).getWinner()).toBe(Winner.BLUE)
  expect(new RoundHelper(round_status_red).getWinner()).toBe(Winner.RED)
  expect(new RoundHelper(round_status_blue).getWinner()).toBe(Winner.BLUE)
  expect(new RoundHelper(round_only_warning_blue).getWinner()).toBe(Winner.NONE)
  expect(new RoundHelper(round_only_warning_red).getWinner()).toBe(Winner.NONE)
  expect(new RoundHelper(round_only_warning).getWinner()).toBe(Winner.NONE)
  expect(new RoundHelper(round).getWinner()).toBe(Winner.BLUE)
})

it('hasWarnings()', () => {
  expect(new RoundHelper(round_empty).hasWarnings()).toBe(false)
  expect(new RoundHelper(round_points_red).hasWarnings()).toBe(false)
  expect(new RoundHelper(round_points_blue).hasWarnings()).toBe(false)
  expect(new RoundHelper(round_points_only_blue).hasWarnings()).toBe(false)
  expect(new RoundHelper(round_status_red).hasWarnings()).toBe(false)
  expect(new RoundHelper(round_status_blue).hasWarnings()).toBe(false)
  expect(new RoundHelper(round_only_warning_blue).hasWarnings()).toBe(true)
  expect(new RoundHelper(round_only_warning_red).hasWarnings()).toBe(true)
  expect(new RoundHelper(round_only_warning).hasWarnings()).toBe(true)
  expect(new RoundHelper(round).hasWarnings()).toBe(true)
})

it('hasOnlyWarnings()', () => {
  expect(new RoundHelper(round_empty).hasOnlyWarnings()).toBe(false)
  expect(new RoundHelper(round_points_red).hasOnlyWarnings()).toBe(false)
  expect(new RoundHelper(round_points_blue).hasOnlyWarnings()).toBe(false)
  expect(new RoundHelper(round_points_only_blue).hasOnlyWarnings()).toBe(false)
  expect(new RoundHelper(round_status_red).hasOnlyWarnings()).toBe(false)
  expect(new RoundHelper(round_status_blue).hasOnlyWarnings()).toBe(false)
  expect(new RoundHelper(round_only_warning_blue).hasOnlyWarnings()).toBe(true)
  expect(new RoundHelper(round_only_warning_red).hasOnlyWarnings()).toBe(true)
  expect(new RoundHelper(round_only_warning).hasOnlyWarnings()).toBe(true)
  expect(new RoundHelper(round).hasOnlyWarnings()).toBe(false)
})

const round_empty = {
}

const round_points_red = {
  red: Point.FOUR,
  blue: Point.ONE
}

const round_points_blue = {
  red: Point.TWO,
  blue: Point.THREE
}

const round_points_only_blue = {
  red: Point.ZERO,
  blue: Point.FIVE
}

const round_status_red = {
  red: Point.WINNER,
  blue: Point.DISQUALIFIED
}

const round_status_blue = {
  red: Point.KO,
  blue: Point.WINNER
}

const round_only_warning = {
  redWarning: Point.ONE,
  blueWarning: Point.TWO
}

const round_only_warning_red = {
  redWarning: Point.ONE
}

const round_only_warning_blue = {
  blueWarning: Point.TWO
}

const round = {
  redWarning: Point.ONE,
  blueWarning: Point.TWO,
  red: Point.ZERO,
  blue: Point.FIVE
}