import StartHelper from './../util/StartHelper'

it('new StartHelper()', () => {
  const startHelper = new StartHelper(start_three_1)
  expect(startHelper).toBeDefined()
})

it('hasResult()', () => {
  expect(new StartHelper(start_three_1).hasResult()).toBe(true)
  expect(new StartHelper(start_three_2).hasResult()).toBe(true)
  expect(new StartHelper(start_three_3).hasResult()).toBe(true)
  expect(new StartHelper(start_five).hasResult()).toBe(true)
  expect(new StartHelper(start_no_result_1).hasResult()).toBe(false)
  expect(new StartHelper(start_no_result_2).hasResult()).toBe(false)
  expect(new StartHelper(start_no_result_3).hasResult()).toBe(false)
  expect(new StartHelper(start_no_result_4).hasResult()).toBe(false)
  expect(new StartHelper(start_no_result_5).hasResult()).toBe(false)
  expect(new StartHelper(start_overall_9).hasResult()).toBe(true)
  expect(new StartHelper(start_disabled_true).hasResult()).toBe(false)
  expect(new StartHelper(start_disabled_false).hasResult()).toBe(false)
})

it('getOverallStanding()', () => {
  expect(new StartHelper(start_three_1).getOverallStanding()).toBe(9.55)
  expect(new StartHelper(start_three_2).getOverallStanding()).toBe(9.55)
  expect(new StartHelper(start_three_3).getOverallStanding()).toBe(9.55)
  expect(new StartHelper(start_five).getOverallStanding()).toBe(9.61)
  expect(new StartHelper(start_no_result_1).getOverallStanding()).toBe(undefined)
  expect(new StartHelper(start_no_result_2).getOverallStanding()).toBe(undefined)
  expect(new StartHelper(start_no_result_3).getOverallStanding()).toBe(undefined)
  expect(new StartHelper(start_no_result_4).getOverallStanding()).toBe(undefined)
  expect(new StartHelper(start_no_result_5).getOverallStanding()).toBe(undefined)
  expect(new StartHelper(start_overall_9).getOverallStanding()).toBe(9.00)
  expect(new StartHelper(start_disabled_true).getOverallStanding()).toBe(undefined)
  expect(new StartHelper(start_disabled_false).getOverallStanding()).toBe(undefined)
})

it('getOverallStandingDisplay()', () => {
  expect(new StartHelper(start_three_1).getOverallStandingDisplay()).toBe("9.55")
  expect(new StartHelper(start_three_2).getOverallStandingDisplay()).toBe("9.55")
  expect(new StartHelper(start_three_3).getOverallStandingDisplay()).toBe("9.55")
  expect(new StartHelper(start_five).getOverallStandingDisplay()).toBe("9.61")
  expect(new StartHelper(start_no_result_1).getOverallStandingDisplay()).toBe(undefined)
  expect(new StartHelper(start_no_result_2).getOverallStandingDisplay()).toBe(undefined)
  expect(new StartHelper(start_no_result_3).getOverallStandingDisplay()).toBe(undefined)
  expect(new StartHelper(start_no_result_4).getOverallStandingDisplay()).toBe(undefined)
  expect(new StartHelper(start_no_result_5).getOverallStandingDisplay()).toBe(undefined)
  expect(new StartHelper(start_overall_9).getOverallStandingDisplay()).toBe("9.00")
  expect(new StartHelper(start_disabled_true).getOverallStandingDisplay()).toBe(undefined)
  expect(new StartHelper(start_disabled_false).getOverallStandingDisplay()).toBe(undefined)
})

it('sortByResults()', () => {
  expect(new StartHelper(start_three_1).sortByResults()).toStrictEqual([9.15,9.51,9.98])
  expect(new StartHelper(start_three_2).sortByResults()).toStrictEqual([9.15,9.51,9.98])
  expect(new StartHelper(start_three_3).sortByResults()).toStrictEqual([9.15,9.51,9.98])
  expect(new StartHelper(start_five).sortByResults()).toStrictEqual([9.15,9.51,9.54,9.77,9.98])
  expect(new StartHelper(start_overall_9).sortByResults()).toStrictEqual([9.00,9.00,9.00,])
})

it('getCompetitorsDisplay()', () => {
  expect(new StartHelper(start_competitors_one).getCompetitorsDisplay()).toBe('Lukas Maier')
  expect(new StartHelper(start_competitors_two).getCompetitorsDisplay()).toBe('Lukas Maier, Thomas Achorner')
  expect(new StartHelper(start_competitors_three).getCompetitorsDisplay()).toBe('Lukas Maier, Thomas Achorner, Tanja Hauser')
  expect(new StartHelper(start_disabled_true).getCompetitorsDisplay()).toBe('Lukas Maier')
  expect(new StartHelper(start_disabled_false).getCompetitorsDisplay()).toBe('Lukas Maier')
})

it('isDisabled()', () => {
  expect(new StartHelper(start_overall_9).isDisabled()).toBe(false)
  expect(new StartHelper(start_disabled_true).isDisabled()).toBe(true)
  expect(new StartHelper(start_disabled_false).isDisabled()).toBe(false)
})

it('isFinished()', () => {
  expect(new StartHelper(start_three_1).isFinished()).toBe(true)
  expect(new StartHelper(start_three_2).isFinished()).toBe(true)
  expect(new StartHelper(start_three_3).isFinished()).toBe(true)
  expect(new StartHelper(start_five).isFinished()).toBe(true)
  expect(new StartHelper(start_no_result_1).isFinished()).toBe(false)
  expect(new StartHelper(start_no_result_2).isFinished()).toBe(false)
  expect(new StartHelper(start_no_result_3).isFinished()).toBe(false)
  expect(new StartHelper(start_no_result_4).isFinished()).toBe(false)
  expect(new StartHelper(start_no_result_5).isFinished()).toBe(false)
  expect(new StartHelper(start_overall_9).isFinished()).toBe(true)
  expect(new StartHelper(start_disabled_true).isFinished()).toBe(true)
  expect(new StartHelper(start_disabled_false).isFinished()).toBe(false)
})

const start_no_result_1 = {
  competitors: [
    'Lukas Maier'
  ],
  results: []
}

const start_no_result_2 = {
  competitors: [
    'Lukas Maier'
  ],
  results: ['']
}

const start_no_result_3 = {
  competitors: [
    'Lukas Maier'
  ],
  results: ['', '', '', '', '']
}

const start_no_result_4 = {
  competitors: [
    'Lukas Maier'
  ],
  results: [1.11, 2.22, 3.33, 4.44]
}

const start_no_result_5 = {
  competitors: [
    'Lukas Maier'
  ],
  results: [1.11, 2.22]
}

const start_three_1 = {
  competitors: [
    'Lukas Maier'
  ],
  results: [
    9.51,
    9.15,
    9.98,
    '',
    ''
  ]
}

const start_three_2 = {
  competitors: [
    'Lukas Maier'
  ],
  results: [
    '',
    9.51,
    9.15,
    9.98,
    ''
  ]
}

const start_three_3 = {
  competitors: [
    'Lukas Maier'
  ],
  results: [
    9.51,
    '',
    9.15,
    '',
    9.98
  ]
}

const start_five = {
  competitors: [
    'Lukas Maier'
  ],
  results: [
    9.98,
    9.54,
    9.51,
    9.77,
    9.15
  ]
}

const start_overall_9 = {
  competitors: [
    'Lukas Maier'
  ],
  results: [9, 9, 9]
}

const start_competitors_one = {
  competitors: [
    'Lukas Maier'
  ],
  results: []
}

const start_competitors_two = {
  competitors: [
    'Lukas Maier', 'Thomas Achorner'
  ],
  results: []
}

const start_competitors_three = {
  competitors: [
    'Lukas Maier', 'Thomas Achorner', 'Tanja Hauser'
  ],
  results: []
}

const start_disabled_true = {
  competitors: [
    'Lukas Maier'
  ],
  results: [],
  disabled: true
}

const start_disabled_false = {
  competitors: [
    'Lukas Maier'
  ],
  results: [],
  disabled: false
}