import posed from 'react-pose'

// https://popmotion.io/pose/

const PosedLeftToRight = posed.div({
    hidden: {
        opacity: 0,
        x: '-100%'
    },
    visible: {
        opacity: 1,
        x: 0,
        transition: ({ i }) => ({ delay: i * 100 })
    },
    props: {
        i: 0
    }
})

const PosedRightToLeft = posed.div({
    hidden: {
        opacity: 0,
        x: '100%'
    },
    visible: {
        opacity: 1,
        x: 0,
        transition: ({ i }) => ({ delay: i * 100 })
    },
    props: {
        i: 0
    }
})

const PosedBottomToTop = posed.div({
    hidden: {
        opacity: 0,
        y: '100%',
    },
    visible: {
        opacity: 1,
        y: 0,
        transition: ({ i }) => ({ delay: i * 100 })
    },
    props: {
        i: 0
    }
})

const PosedDropIn = posed.div({
    ready: {
        opacity: 0,
        scale: 2
    },
    drop: {
        opacity: 1,
        scale: 1,
        transition: ({ i }) => ({ delay: i * 100 })
    },
    props: {
        i: 0
    }
})

const PosedDropInImg = posed.img({
    hidden: {
        opacity: 0,
        scale: 2
    },
    visible: {
        opacity: 1,
        scale: 1,
        transition: ({ i }) => ({ delay: i * 100 })
    },
    props: {
        i: 0
    }
})

export {
    PosedLeftToRight,
    PosedRightToLeft,
    PosedBottomToTop,
    PosedDropIn,
    PosedDropInImg
}