const Winner = require('./Winner')

class RoundHelper {
    constructor(round) {
        this.round = round
    }

    hasPoints() {
       const red = this.round.red
       const blue = this.round.blue
       return (red !== undefined && red.type === 'point') || (blue !== undefined && blue.type === 'point')
    }

    hasStatus() {
       const red = this.round.red
       const blue = this.round.blue
       return (red !== undefined && red.type === 'status') || (blue !== undefined && blue.type === 'status')
    }

    hasWarnings() {
      const redWarning = this.round.redWarning
      const blueWarning = this.round.blueWarning
      return (redWarning !== undefined && redWarning.type === 'point') || (blueWarning !== undefined && blueWarning.type === 'point')
    }

    hasOnlyWarnings() {
       return this.hasPoints() === false && this.hasStatus() === false && this.hasWarnings()
    }

    getWinner() {
       if (this.hasPoints() === false && this.hasStatus() === false) {
          return Winner.NONE
       }

       const redValue = this.round.red.value
       const blueValue = this.round.blue.value
       if (redValue > blueValue) {
          return Winner.RED
       } else if (blueValue > redValue) {
          return Winner.BLUE
       } else {
          return Winner.TIE
       }
    }
}

module.exports = RoundHelper