const fs = require('fs')

const competitionFileName = './data/competition.json'
const fightsFileName = './data/fights.json'
const formsFileName = './data/forms.json'

let competition = JSON.parse(fs.readFileSync(competitionFileName))
let fights = JSON.parse(fs.readFileSync(fightsFileName))
let forms = JSON.parse(fs.readFileSync(formsFileName))

const loadCompetition = () => competition = JSON.parse(fs.readFileSync(competitionFileName))
const getCompetition = (key = undefined) => {
    if (key !== undefined) {
        return competition[key]
    }
    return competition
}

const loadFights = () => fights = JSON.parse(fs.readFileSync(fightsFileName))
const getFights = () => fights
const getFight = (id) => fights.find(fight => fight.id === id)
const saveFights = () =>  fs.writeFile(fightsFileName, JSON.stringify(fights, null, 2), () => {})

const loadForms = () => forms = JSON.parse(fs.readFileSync(formsFileName))
const getForms = () => forms
const getForm = (id) => forms.find(form => form.id === id)
const saveForms = () => fs.writeFile(formsFileName, JSON.stringify(forms, null, 2), () => {})

module.exports = {
    loadCompetition,
    getCompetition,
    loadFights,
    getFights,
    getFight,
    saveFights,
    loadForms,
    getForms,
    getForm,
    saveForms
}